require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_PMAP_H_)) {
    eval 'sub _MACHINE_PMAP_H_ () {1;}' unless defined(&_MACHINE_PMAP_H_);
    eval 'sub PG_V () {0x1;}' unless defined(&PG_V);
    eval 'sub PG_RW () {0x2;}' unless defined(&PG_RW);
    eval 'sub PG_U () {0x4;}' unless defined(&PG_U);
    eval 'sub PG_NC_PWT () {0x8;}' unless defined(&PG_NC_PWT);
    eval 'sub PG_NC_PCD () {0x10;}' unless defined(&PG_NC_PCD);
    eval 'sub PG_A () {0x20;}' unless defined(&PG_A);
    eval 'sub PG_M () {0x40;}' unless defined(&PG_M);
    eval 'sub PG_PS () {0x80;}' unless defined(&PG_PS);
    eval 'sub PG_PTE_PAT () {0x80;}' unless defined(&PG_PTE_PAT);
    eval 'sub PG_G () {0x100;}' unless defined(&PG_G);
    eval 'sub PG_AVAIL1 () {0x200;}' unless defined(&PG_AVAIL1);
    eval 'sub PG_AVAIL2 () {0x400;}' unless defined(&PG_AVAIL2);
    eval 'sub PG_AVAIL3 () {0x800;}' unless defined(&PG_AVAIL3);
    eval 'sub PG_PDE_PAT () {0x1000;}' unless defined(&PG_PDE_PAT);
    eval 'sub PG_W () { &PG_AVAIL1;}' unless defined(&PG_W);
    eval 'sub PG_MANAGED () { &PG_AVAIL2;}' unless defined(&PG_MANAGED);
    eval 'sub PG_FRAME () {(~(( &vm_paddr_t) &PAGE_MASK));}' unless defined(&PG_FRAME);
    eval 'sub PG_PROT () {( &PG_RW| &PG_U);}' unless defined(&PG_PROT);
    eval 'sub PG_N () {( &PG_NC_PWT| &PG_NC_PCD);}' unless defined(&PG_N);
    eval 'sub PGEX_P () {0x1;}' unless defined(&PGEX_P);
    eval 'sub PGEX_W () {0x2;}' unless defined(&PGEX_W);
    eval 'sub PGEX_U () {0x4;}' unless defined(&PGEX_U);
    unless(defined(&KVA_PAGES)) {
	if(defined(&PAE)) {
	    eval 'sub KVA_PAGES () {512;}' unless defined(&KVA_PAGES);
	} else {
	    eval 'sub KVA_PAGES () {256;}' unless defined(&KVA_PAGES);
	}
    }
    eval 'sub VADDR {
        my($pdi, $pti) = @_;
	    eval q((( &vm_offset_t)((($pdi)<< &PDRSHIFT)|(($pti)<< &PAGE_SHIFT))));
    }' unless defined(&VADDR);
    unless(defined(&NKPT)) {
	if(defined(&PAE)) {
	    eval 'sub NKPT () {240;}' unless defined(&NKPT);
	} else {
	    eval 'sub NKPT () {30;}' unless defined(&NKPT);
	}
    }
    unless(defined(&NKPDE)) {
	if(defined(&SMP)) {
	    eval 'sub NKPDE () {( &KVA_PAGES - 1);}' unless defined(&NKPDE);
	} else {
	    eval 'sub NKPDE () {( &KVA_PAGES);}' unless defined(&NKPDE);
	}
    }
    if(defined(&SMP)) {
	eval 'sub MPPTDI () {( &NPDEPTD-1);}' unless defined(&MPPTDI);
	eval 'sub KPTDI () {( &MPPTDI- &NKPDE);}' unless defined(&KPTDI);
    } else {
	eval 'sub KPTDI () {( &NPDEPTD- &NKPDE);}' unless defined(&KPTDI);
    }
    eval 'sub PTDPTDI () {( &KPTDI- &NPGPTD);}' unless defined(&PTDPTDI);
    eval 'sub ISA_HOLE_START () {0xa0000;}' unless defined(&ISA_HOLE_START);
    eval 'sub ISA_HOLE_LENGTH () {(0x100000- &ISA_HOLE_START);}' unless defined(&ISA_HOLE_LENGTH);
    unless(defined(&LOCORE)) {
	require 'sys/queue.ph';
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	if(defined(&PAE)) {
	    eval 'sub PTESHIFT () {(3);}' unless defined(&PTESHIFT);
	    eval 'sub PDESHIFT () {(3);}' unless defined(&PDESHIFT);
	} else {
	    eval 'sub PTESHIFT () {(2);}' unless defined(&PTESHIFT);
	    eval 'sub PDESHIFT () {(2);}' unless defined(&PDESHIFT);
	}
	if(defined(&_KERNEL)) {
	    if(defined(&PAE)) {
	    }
	}
	if(defined(&_KERNEL)) {
	    eval 'sub vtopte {
	        my($va) = @_;
    		eval q(( &PTmap +  &i386_btop($va)));
	    }' unless defined(&vtopte);
	    eval 'sub vtophys {
	        my($va) = @_;
    		eval q( &pmap_kextract((( &vm_offset_t) ($va))));
	    }' unless defined(&vtophys);
	    if(defined(&PAE)) {
		eval 'sub pte_load {
		    my($ptep) = @_;
    		    eval q({  &pt_entry_t  &r;  &__asm  &__volatile( \\"lock; cmpxchg8b %1\\" : \\"=A\\" ( &r) : \\"m\\" (*$ptep), \\"a\\" (0), \\"d\\" (0), \\"b\\" (0), \\"c\\" (0)); ( &r); });
		}' unless defined(&pte_load);
		eval 'sub pte_load_store {
		    my($ptep,$v) = @_;
    		    eval q({  &pt_entry_t  &r;  &r = *$ptep;  &__asm  &__volatile( \\"1:\\\\n\\" \\"\\\\tlock; cmpxchg8b %1\\\\n\\" \\"\\\\tjnz 1b\\" : \\"+A\\" ( &r) : \\"m\\" (*$ptep), \\"b\\" (( &uint32_t)$v), \\"c\\" (( &uint32_t)($v >> 32))); ( &r); });
		}' unless defined(&pte_load_store);
		eval 'sub pte_load_clear {
		    my($ptep) = @_;
    		    eval q( &pte_load_store(($ptep), ( &pt_entry_t)0));
		}' unless defined(&pte_load_clear);
		eval 'sub pte_store {
		    my($ptep, $pte) = @_;
    		    eval q( &pte_load_store(($ptep), ( &pt_entry_t)$pte));
		}' unless defined(&pte_store);
	    } else {
		eval 'sub pte_load {
		    my($ptep) = @_;
    		    eval q({  &pt_entry_t  &r;  &r = *$ptep; ( &r); });
		}' unless defined(&pte_load);
		eval 'sub pte_load_store {
		    my($ptep,$pte) = @_;
    		    eval q({  &pt_entry_t  &r;  &__asm  &__volatile( \\"xchgl %0,%1\\" : \\"=m\\" (*$ptep), \\"=r\\" ( &r) : \\"1\\" ($pte), \\"m\\" (*$ptep)); ( &r); });
		}' unless defined(&pte_load_store);
		eval 'sub pte_load_clear {
		    my($pte) = @_;
    		    eval q( &atomic_readandclear_int($pte));
		}' unless defined(&pte_load_clear);
		eval 'sub pte_store {
		    my($ptep,$pte) = @_;
    		    eval q({ *$ptep = $pte; });
		}' unless defined(&pte_store);
	    }
	    eval 'sub pte_clear {
	        my($ptep) = @_;
    		eval q( &pte_store(($ptep), ( &pt_entry_t)0));
	    }' unless defined(&pte_clear);
	    eval 'sub pde_store {
	        my($pdep, $pde) = @_;
    		eval q( &pte_store(($pdep), ($pde)));
	    }' unless defined(&pde_store);
	}
	if(defined(&PAE)) {
	}
	if(defined(&_KERNEL)) {
	    eval 'sub kernel_pmap () {( &kernel_pmap_store);}' unless defined(&kernel_pmap);
	    eval 'sub PMAP_LOCK {
	        my($pmap) = @_;
    		eval q( &mtx_lock(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_LOCK);
	    eval 'sub PMAP_LOCK_ASSERT {
	        my($pmap, $type) = @_;
    		eval q( &mtx_assert(($pmap)-> &pm_mtx, ($type)));
	    }' unless defined(&PMAP_LOCK_ASSERT);
	    eval 'sub PMAP_LOCK_DESTROY {
	        my($pmap) = @_;
    		eval q( &mtx_destroy(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_LOCK_DESTROY);
	    eval 'sub PMAP_LOCK_INIT {
	        my($pmap) = @_;
    		eval q( &mtx_init(($pmap)-> &pm_mtx, \\"pmap\\",  &NULL,  &MTX_DEF |  &MTX_DUPOK));
	    }' unless defined(&PMAP_LOCK_INIT);
	    eval 'sub PMAP_LOCKED {
	        my($pmap) = @_;
    		eval q( &mtx_owned(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_LOCKED);
	    eval 'sub PMAP_MTX {
	        my($pmap) = @_;
    		eval q((($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_MTX);
	    eval 'sub PMAP_TRYLOCK {
	        my($pmap) = @_;
    		eval q( &mtx_trylock(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_TRYLOCK);
	    eval 'sub PMAP_UNLOCK {
	        my($pmap) = @_;
    		eval q( &mtx_unlock(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_UNLOCK);
	}
	if(defined(&_KERNEL)) {
	    eval 'sub NPPROVMTRR () {8;}' unless defined(&NPPROVMTRR);
	    eval 'sub PPRO_VMTRRphysBase0 () {0x200;}' unless defined(&PPRO_VMTRRphysBase0);
	    eval 'sub PPRO_VMTRRphysMask0 () {0x201;}' unless defined(&PPRO_VMTRRphysMask0);
	    eval 'sub pmap_page_is_mapped {
	        my($m) = @_;
    		eval q((! &TAILQ_EMPTY(($m)-> ($md->{pv_list}))));
	    }' unless defined(&pmap_page_is_mapped);
	    eval 'sub pmap_unmapbios {
	        my($va, $sz) = @_;
    		eval q( &pmap_unmapdev(($va), ($sz)));
	    }' unless defined(&pmap_unmapbios);
	}
    }
}
1;
