require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FILE_H_)) {
    eval 'sub _SYS_FILE_H_ () {1;}' unless defined(&_SYS_FILE_H_);
    unless(defined(&_KERNEL)) {
	require 'sys/types.ph';
	require 'sys/fcntl.ph';
	require 'sys/unistd.ph';
    } else {
	require 'sys/queue.ph';
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
    }
    eval 'sub DTYPE_VNODE () {1;}' unless defined(&DTYPE_VNODE);
    eval 'sub DTYPE_SOCKET () {2;}' unless defined(&DTYPE_SOCKET);
    eval 'sub DTYPE_PIPE () {3;}' unless defined(&DTYPE_PIPE);
    eval 'sub DTYPE_FIFO () {4;}' unless defined(&DTYPE_FIFO);
    eval 'sub DTYPE_KQUEUE () {5;}' unless defined(&DTYPE_KQUEUE);
    eval 'sub DTYPE_CRYPTO () {6;}' unless defined(&DTYPE_CRYPTO);
    if(defined(&_KERNEL)) {
	eval 'sub FOF_OFFSET () {1;}' unless defined(&FOF_OFFSET);
	eval 'sub DFLAG_PASSABLE () {0x1;}' unless defined(&DFLAG_PASSABLE);
	eval 'sub DFLAG_SEEKABLE () {0x2;}' unless defined(&DFLAG_SEEKABLE);
	eval 'sub FOFFSET_LOCKED () {0x1;}' unless defined(&FOFFSET_LOCKED);
	eval 'sub FOFFSET_LOCK_WAITING () {0x2;}' unless defined(&FOFFSET_LOCK_WAITING);
	eval 'sub FMARK () {0x1;}' unless defined(&FMARK);
	eval 'sub FDEFER () {0x2;}' unless defined(&FDEFER);
	eval 'sub FWAIT () {0x4;}' unless defined(&FWAIT);
    }
    if(defined(&_KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
	eval 'sub FILE_LOCK {
	    my($f) = @_;
    	    eval q( &mtx_lock(($f)-> &f_mtxp));
	}' unless defined(&FILE_LOCK);
	eval 'sub FILE_UNLOCK {
	    my($f) = @_;
    	    eval q( &mtx_unlock(($f)-> &f_mtxp));
	}' unless defined(&FILE_UNLOCK);
	eval 'sub FILE_LOCKED {
	    my($f) = @_;
    	    eval q( &mtx_owned(($f)-> &f_mtxp));
	}' unless defined(&FILE_LOCKED);
	eval 'sub FILE_LOCK_ASSERT {
	    my($f, $type) = @_;
    	    eval q( &mtx_assert(($f)-> &f_mtxp, ($type)));
	}' unless defined(&FILE_LOCK_ASSERT);
	eval 'sub fhold_locked {
	    my($fp) = @_;
    	    eval q( &do {  &FILE_LOCK_ASSERT($fp,  &MA_OWNED); ($fp)-> &f_count++; }  &while (0));
	}' unless defined(&fhold_locked);
	eval 'sub fhold {
	    my($fp) = @_;
    	    eval q( &do {  &FILE_LOCK($fp); ($fp)-> &f_count++;  &FILE_UNLOCK($fp); }  &while (0));
	}' unless defined(&fhold);
	eval 'sub fo_read {
	    my($fp,$uio,$active_cred,$flags,$td) = @_;
    	    eval q(*$fp; \'struct uio\' *$uio; \'struct ucred\' *$active_cred; \'int\' $flags; \'struct thread\' *$td; { ((* ($fp->{f_ops}->{fo_read}))($fp, $uio, $active_cred, $flags, $td)); });
	}' unless defined(&fo_read);
	eval 'sub fo_write {
	    my($fp,$uio,$active_cred,$flags,$td) = @_;
    	    eval q(*$fp; \'struct uio\' *$uio; \'struct ucred\' *$active_cred; \'int\' $flags; \'struct thread\' *$td; { ((* ($fp->{f_ops}->{fo_write}))($fp, $uio, $active_cred, $flags, $td)); });
	}' unless defined(&fo_write);
	eval 'sub fo_ioctl {
	    my($fp,$com,$data,$active_cred,$td) = @_;
    	    eval q(*$fp; my $com;  &void *$data; \'struct ucred\' *$active_cred; \'struct thread\' *$td; { ((* ($fp->{f_ops}->{fo_ioctl}))($fp, $com, $data, $active_cred, $td)); });
	}' unless defined(&fo_ioctl);
	eval 'sub fo_poll {
	    my($fp,$events,$active_cred,$td) = @_;
    	    eval q(*$fp; \'int\' $events; \'struct ucred\' *$active_cred; \'struct thread\' *$td; { ((* ($fp->{f_ops}->{fo_poll}))($fp, $events, $active_cred, $td)); });
	}' unless defined(&fo_poll);
	eval 'sub fo_stat {
	    my($fp,$sb,$active_cred,$td) = @_;
    	    eval q(*$fp; \'struct stat\' *$sb; \'struct ucred\' *$active_cred; \'struct thread\' *$td; { ((* ($fp->{f_ops}->{fo_stat}))($fp, $sb, $active_cred, $td)); });
	}' unless defined(&fo_stat);
	eval 'sub fo_close {
	    my($fp,$td) = @_;
    	    eval q(*$fp; \'struct thread\' *$td; { ((* ($fp->{f_ops}->{fo_close}))($fp, $td)); });
	}' unless defined(&fo_close);
	eval 'sub fo_kqfilter {
	    my($fp,$kn) = @_;
    	    eval q(*$fp; \'struct knote\' *$kn; { ((* ($fp->{f_ops}->{fo_kqfilter}))($fp, $kn)); });
	}' unless defined(&fo_kqfilter);
    }
}
1;
