require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_FILEDESC_H_)) {
    eval 'sub _SYS_FILEDESC_H_ () {1;}' unless defined(&_SYS_FILEDESC_H_);
    require 'sys/queue.ph';
    require 'sys/event.ph';
    require 'sys/priority.ph';
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    require 'machine/_limits.ph';
    eval 'sub NDSLOTTYPE () {\'u_long\';}' unless defined(&NDSLOTTYPE);
    eval 'sub UF_EXCLOSE () {0x1;}' unless defined(&UF_EXCLOSE);
    eval 'sub UF_OPENING () {0x2;}' unless defined(&UF_OPENING);
    if(defined(&_KERNEL)) {
	eval 'sub FILEDESC_LOCK {
	    my($fd) = @_;
    	    eval q( &do {  &mtx_lock(($fd)-> &fd_mtx); ($fd)-> &fd_wanted++;  &while (($fd)-> &fd_locked)  &msleep(($fd)-> &fd_locked, ($fd)-> &fd_mtx,  &PLOCK, \\"fdesc\\", 0); ($fd)-> &fd_locked = 2; ($fd)-> &fd_wanted--;  &mtx_unlock(($fd)-> &fd_mtx); }  &while (0));
	}' unless defined(&FILEDESC_LOCK);
	eval 'sub FILEDESC_UNLOCK {
	    my($fd) = @_;
    	    eval q( &do {  &mtx_lock(($fd)-> &fd_mtx);  &KASSERT(($fd)-> &fd_locked == 2, (\\"fdesc locking mistake %d should be %d\\", ($fd)-> &fd_locked, 2)); ($fd)-> &fd_locked = 0;  &if (($fd)-> &fd_wanted)  &wakeup(($fd)-> &fd_locked);  &mtx_unlock(($fd)-> &fd_mtx); }  &while (0));
	}' unless defined(&FILEDESC_UNLOCK);
	eval 'sub FILEDESC_LOCK_FAST {
	    my($fd) = @_;
    	    eval q( &do {  &mtx_lock(($fd)-> &fd_mtx); ($fd)-> &fd_wanted++;  &while (($fd)-> &fd_locked)  &msleep(($fd)-> &fd_locked, ($fd)-> &fd_mtx,  &PLOCK, \\"fdesc\\", 0); ($fd)-> &fd_locked = 1; ($fd)-> &fd_wanted--; }  &while (0));
	}' unless defined(&FILEDESC_LOCK_FAST);
	eval 'sub FILEDESC_UNLOCK_FAST {
	    my($fd) = @_;
    	    eval q( &do {  &KASSERT(($fd)-> &fd_locked == 1, (\\"fdesc locking mistake %d should be %d\\", ($fd)-> &fd_locked, 1)); ($fd)-> &fd_locked = 0;  &if (($fd)-> &fd_wanted)  &wakeup(($fd)-> &fd_locked);  &mtx_unlock(($fd)-> &fd_mtx); }  &while (0));
	}' unless defined(&FILEDESC_UNLOCK_FAST);
	if(defined(&INVARIANT_SUPPORT)) {
	    eval 'sub FILEDESC_LOCK_ASSERT {
	        my($fd, $arg) = @_;
    		eval q( &do {  &if (($arg) ==  &MA_OWNED)  &KASSERT(($fd)-> &fd_locked != 0, (\\"fdesc locking mistake\\"));  &else  &KASSERT(($fd)-> &fd_locked == 0, (\\"fdesc locking mistake\\")); }  &while (0));
	    }' unless defined(&FILEDESC_LOCK_ASSERT);
	} else {
	    eval 'sub FILEDESC_LOCK_ASSERT {
	        my($fd, $arg) = @_;
    		eval q();
	    }' unless defined(&FILEDESC_LOCK_ASSERT);
	}
	eval 'sub FILEDESC_LOCK_DESC () {"filedesc structure";}' unless defined(&FILEDESC_LOCK_DESC);
	eval 'sub fget_locked {
	    my($fdp,$fd) = @_;
    	    eval q({ ($fd < 0|| $fd >=  ($fdp->{fd_nfiles}) ?  &NULL :  ($fdp->{fd_ofiles[$fd]})); });
	}' unless defined(&fget_locked);
    }
}
1;
