require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_MUTEX_H_)) {
    eval 'sub _SYS_MUTEX_H_ () {1;}' unless defined(&_SYS_MUTEX_H_);
    unless(defined(&LOCORE)) {
	require 'sys/queue.ph';
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	if(defined(&_KERNEL)) {
	    require 'sys/pcpu.ph';
	    require 'machine/atomic.ph';
	    require 'machine/cpufunc.ph';
	}
    }
    require 'machine/mutex.ph';
    if(defined(&_KERNEL)) {
	eval 'sub MTX_DEF () {0x;}' unless defined(&MTX_DEF);
	eval 'sub MTX_SPIN () {0x1;}' unless defined(&MTX_SPIN);
	eval 'sub MTX_RECURSE () {0x4;}' unless defined(&MTX_RECURSE);
	eval 'sub MTX_NOWITNESS () {0x8;}' unless defined(&MTX_NOWITNESS);
	eval 'sub MTX_QUIET () { &LOP_QUIET;}' unless defined(&MTX_QUIET);
	eval 'sub MTX_DUPOK () { &LOP_DUPOK;}' unless defined(&MTX_DUPOK);
	eval 'sub MTX_RECURSED () {0x1;}' unless defined(&MTX_RECURSED);
	eval 'sub MTX_CONTESTED () {0x2;}' unless defined(&MTX_CONTESTED);
	eval 'sub MTX_UNOWNED () {0x4;}' unless defined(&MTX_UNOWNED);
	eval 'sub MTX_FLAGMASK () {~( &MTX_RECURSED |  &MTX_CONTESTED);}' unless defined(&MTX_FLAGMASK);
	eval 'sub MTX_DESTROYED () {( &MTX_CONTESTED |  &MTX_UNOWNED);}' unless defined(&MTX_DESTROYED);
    }
    unless(defined(&LOCORE)) {
	eval 'sub mp_fixme {
	    my($string) = @_;
    	    eval q();
	}' unless defined(&mp_fixme);
	if(defined(&_KERNEL)) {
	    if(defined(&SMP)) {
	    }
	    if(defined( &INVARIANTS) || defined( &INVARIANT_SUPPORT)) {
	    }
	    unless(defined(&_obtain_lock)) {
		eval 'sub _obtain_lock {
		    my($mp, $tid) = @_;
    		    eval q( &atomic_cmpset_acq_ptr(($mp)-> &mtx_lock,  &MTX_UNOWNED, ($tid)));
		}' unless defined(&_obtain_lock);
	    }
	    unless(defined(&_release_lock)) {
		eval 'sub _release_lock {
		    my($mp, $tid) = @_;
    		    eval q( &atomic_cmpset_rel_ptr(($mp)-> &mtx_lock, ($tid),  &MTX_UNOWNED));
		}' unless defined(&_release_lock);
	    }
	    unless(defined(&_release_lock_quick)) {
		eval 'sub _release_lock_quick {
		    my($mp) = @_;
    		    eval q( &atomic_store_rel_ptr(($mp)-> &mtx_lock,  &MTX_UNOWNED));
		}' unless defined(&_release_lock_quick);
	    }
	    unless(defined(&_get_sleep_lock)) {
		eval 'sub _get_sleep_lock {
		    my($mp, $tid, $opts, $file, $line) = @_;
    		    eval q( &do {  &uintptr_t  &_tid = ( &uintptr_t)($tid);  &if (! &_obtain_lock(($mp),  &_tid))  &_mtx_lock_sleep(($mp),  &_tid, ($opts), ($file), ($line)); }  &while (0));
		}' unless defined(&_get_sleep_lock);
	    }
	    unless(defined(&_get_spin_lock)) {
		if(defined(&SMP)) {
		    eval 'sub _get_spin_lock {
		        my($mp, $tid, $opts, $file, $line) = @_;
    			eval q( &do {  &uintptr_t  &_tid = ( &uintptr_t)($tid);  &spinlock_enter();  &if (! &_obtain_lock(($mp),  &_tid)) {  &if (($mp)-> &mtx_lock ==  &_tid) ($mp)-> &mtx_recurse++;  &else  &_mtx_lock_spin(($mp),  &_tid, ($opts), ($file), ($line)); } }  &while (0));
		    }' unless defined(&_get_spin_lock);
		} else {
		    eval 'sub _get_spin_lock {
		        my($mp, $tid, $opts, $file, $line) = @_;
    			eval q( &do {  &uintptr_t  &_tid = ( &uintptr_t)($tid);  &spinlock_enter();  &if (($mp)-> &mtx_lock ==  &_tid) ($mp)-> &mtx_recurse++;  &else {  &KASSERT(($mp)-> &mtx_lock ==  &MTX_UNOWNED, (\\"corrupt spinlock\\")); ($mp)-> &mtx_lock =  &_tid; } }  &while (0));
		    }' unless defined(&_get_spin_lock);
		}
	    }
	    unless(defined(&_rel_sleep_lock)) {
		eval 'sub _rel_sleep_lock {
		    my($mp, $tid, $opts, $file, $line) = @_;
    		    eval q( &do {  &uintptr_t  &_tid = ( &uintptr_t)($tid);  &if (! &_release_lock(($mp),  &_tid))  &_mtx_unlock_sleep(($mp), ($opts), ($file), ($line)); }  &while (0));
		}' unless defined(&_rel_sleep_lock);
	    }
	    unless(defined(&_rel_spin_lock)) {
		if(defined(&SMP)) {
		    eval 'sub _rel_spin_lock {
		        my($mp) = @_;
    			eval q( &do {  &if ( &mtx_recursed(($mp))) ($mp)-> &mtx_recurse--;  &else  &_release_lock_quick(($mp));  &spinlock_exit(); }  &while (0));
		    }' unless defined(&_rel_spin_lock);
		} else {
		    eval 'sub _rel_spin_lock {
		        my($mp) = @_;
    			eval q( &do {  &if ( &mtx_recursed(($mp))) ($mp)-> &mtx_recurse--;  &else ($mp)-> &mtx_lock =  &MTX_UNOWNED;  &spinlock_exit(); }  &while (0));
		    }' unless defined(&_rel_spin_lock);
		}
	    }
	    eval 'sub mtx_lock {
	        my($m) = @_;
    		eval q( &mtx_lock_flags(($m), 0));
	    }' unless defined(&mtx_lock);
	    eval 'sub mtx_lock_spin {
	        my($m) = @_;
    		eval q( &mtx_lock_spin_flags(($m), 0));
	    }' unless defined(&mtx_lock_spin);
	    eval 'sub mtx_trylock {
	        my($m) = @_;
    		eval q( &mtx_trylock_flags(($m), 0));
	    }' unless defined(&mtx_trylock);
	    eval 'sub mtx_unlock {
	        my($m) = @_;
    		eval q( &mtx_unlock_flags(($m), 0));
	    }' unless defined(&mtx_unlock);
	    eval 'sub mtx_unlock_spin {
	        my($m) = @_;
    		eval q( &mtx_unlock_spin_flags(($m), 0));
	    }' unless defined(&mtx_unlock_spin);
	    eval 'sub mtx_pool_lock {
	        my($pool, $ptr) = @_;
    		eval q( &mtx_lock( &mtx_pool_find(($pool), ($ptr))));
	    }' unless defined(&mtx_pool_lock);
	    eval 'sub mtx_pool_lock_spin {
	        my($pool, $ptr) = @_;
    		eval q( &mtx_lock_spin( &mtx_pool_find(($pool), ($ptr))));
	    }' unless defined(&mtx_pool_lock_spin);
	    eval 'sub mtx_pool_unlock {
	        my($pool, $ptr) = @_;
    		eval q( &mtx_unlock( &mtx_pool_find(($pool), ($ptr))));
	    }' unless defined(&mtx_pool_unlock);
	    eval 'sub mtx_pool_unlock_spin {
	        my($pool, $ptr) = @_;
    		eval q( &mtx_unlock_spin( &mtx_pool_find(($pool), ($ptr))));
	    }' unless defined(&mtx_pool_unlock_spin);
	    unless(defined(&LOCK_DEBUG)) {
		die("LOCK_DEBUG\ not\ defined\,\ include\ \<sys\/lock\.h\>\ before\ \<sys\/mutex\.h\>");
	    }
	    if((defined(&LOCK_DEBUG) ? &LOCK_DEBUG : 0) > 0|| defined( &MUTEX_NOINLINE)) {
		eval 'sub mtx_lock_flags {
		    my($m, $opts) = @_;
    		    eval q( &_mtx_lock_flags(($m), ($opts),  &LOCK_FILE,  &LOCK_LINE));
		}' unless defined(&mtx_lock_flags);
		eval 'sub mtx_unlock_flags {
		    my($m, $opts) = @_;
    		    eval q( &_mtx_unlock_flags(($m), ($opts),  &LOCK_FILE,  &LOCK_LINE));
		}' unless defined(&mtx_unlock_flags);
		eval 'sub mtx_lock_spin_flags {
		    my($m, $opts) = @_;
    		    eval q( &_mtx_lock_spin_flags(($m), ($opts),  &LOCK_FILE,  &LOCK_LINE));
		}' unless defined(&mtx_lock_spin_flags);
		eval 'sub mtx_unlock_spin_flags {
		    my($m, $opts) = @_;
    		    eval q( &_mtx_unlock_spin_flags(($m), ($opts),  &LOCK_FILE,  &LOCK_LINE));
		}' unless defined(&mtx_unlock_spin_flags);
	    } else {
		eval 'sub mtx_lock_flags {
		    my($m, $opts) = @_;
    		    eval q( &_get_sleep_lock(($m),  &curthread, ($opts),  &LOCK_FILE,  &LOCK_LINE));
		}' unless defined(&mtx_lock_flags);
		eval 'sub mtx_unlock_flags {
		    my($m, $opts) = @_;
    		    eval q( &_rel_sleep_lock(($m),  &curthread, ($opts),  &LOCK_FILE,  &LOCK_LINE));
		}' unless defined(&mtx_unlock_flags);
		eval 'sub mtx_lock_spin_flags {
		    my($m, $opts) = @_;
    		    eval q( &_get_spin_lock(($m),  &curthread, ($opts),  &LOCK_FILE,  &LOCK_LINE));
		}' unless defined(&mtx_lock_spin_flags);
		eval 'sub mtx_unlock_spin_flags {
		    my($m, $opts) = @_;
    		    eval q( &_rel_spin_lock(($m)));
		}' unless defined(&mtx_unlock_spin_flags);
	    }
	    eval 'sub mtx_trylock_flags {
	        my($m, $opts) = @_;
    		eval q( &_mtx_trylock(($m), ($opts),  &LOCK_FILE,  &LOCK_LINE));
	    }' unless defined(&mtx_trylock_flags);
	    eval 'sub mtx_initialized {
	        my($m) = @_;
    		eval q( &lock_initalized(($m)-> &mtx_object));
	    }' unless defined(&mtx_initialized);
	    eval 'sub mtx_owned {
	        my($m) = @_;
    		eval q(((($m)-> &mtx_lock &  &MTX_FLAGMASK) == ( &uintptr_t) &curthread));
	    }' unless defined(&mtx_owned);
	    eval 'sub mtx_recursed {
	        my($m) = @_;
    		eval q((($m)-> &mtx_recurse != 0));
	    }' unless defined(&mtx_recursed);
	    eval 'sub mtx_name {
	        my($m) = @_;
    		eval q((($m)-> ($mtx_object->{lo_name})));
	    }' unless defined(&mtx_name);
	    unless(defined(&DROP_GIANT)) {
		eval 'sub DROP_GIANT () {
		    eval q( &do { \'int\'  &_giantcnt;  &WITNESS_SAVE_DECL( &Giant);  &if ( &mtx_owned( &Giant))  &WITNESS_SAVE( ($Giant->{mtx_object}),  &Giant);  &for ( &_giantcnt = 0;  &mtx_owned( &Giant);  &_giantcnt++)  &mtx_unlock( &Giant));
		}' unless defined(&DROP_GIANT);
		eval 'sub PICKUP_GIANT () {
		    eval q( &mtx_assert( &Giant,  &MA_NOTOWNED);  &while ( &_giantcnt--)  &mtx_lock( &Giant);  &if ( &mtx_owned( &Giant))  &WITNESS_RESTORE( ($Giant->{mtx_object}),  &Giant); }  &while (0));
		}' unless defined(&PICKUP_GIANT);
		eval 'sub PARTIAL_PICKUP_GIANT () {
		    eval q( &mtx_assert( &Giant,  &MA_NOTOWNED);  &while ( &_giantcnt--)  &mtx_lock( &Giant);  &if ( &mtx_owned( &Giant))  &WITNESS_RESTORE( ($Giant->{mtx_object}),  &Giant));
		}' unless defined(&PARTIAL_PICKUP_GIANT);
	    }
	    eval 'sub NET_LOCK_GIANT () {
	        eval q( &do {  &if (! &debug_mpsafenet)  &mtx_lock( &Giant); }  &while (0));
	    }' unless defined(&NET_LOCK_GIANT);
	    eval 'sub NET_UNLOCK_GIANT () {
	        eval q( &do {  &if (! &debug_mpsafenet)  &mtx_unlock( &Giant); }  &while (0));
	    }' unless defined(&NET_UNLOCK_GIANT);
	    eval 'sub NET_ASSERT_GIANT () {
	        eval q( &do {  &if (! &debug_mpsafenet)  &mtx_assert( &Giant,  &MA_OWNED); }  &while (0));
	    }' unless defined(&NET_ASSERT_GIANT);
	    eval 'sub NET_CALLOUT_MPSAFE () {( &debug_mpsafenet ?  &CALLOUT_MPSAFE : 0);}' unless defined(&NET_CALLOUT_MPSAFE);
	    eval 'sub UGAR {
	        my($rval) = @_;
    		eval q( &do { \'int\'  &_val = ($rval);  &mtx_unlock( &Giant);  &return ( &_val); }  &while (0));
	    }' unless defined(&UGAR);
	    eval 'sub MTX_SYSINIT {
	        my($name, $mtx, $desc, $opts) = @_;
    		eval q( &static \'struct mtx_args\' $name &_args = { ($mtx), ($desc), ($opts) };  &SYSINIT($name &_mtx_sysinit,  &SI_SUB_LOCK,  &SI_ORDER_MIDDLE,  &mtx_sysinit, $name &_args);  &SYSUNINIT($name &_mtx_sysuninit,  &SI_SUB_LOCK,  &SI_ORDER_MIDDLE,  &mtx_destroy, ($mtx)));
	    }' unless defined(&MTX_SYSINIT);
	    if(defined( &INVARIANTS) || defined( &INVARIANT_SUPPORT)) {
		eval 'sub MA_OWNED () {0x1;}' unless defined(&MA_OWNED);
		eval 'sub MA_NOTOWNED () {0x2;}' unless defined(&MA_NOTOWNED);
		eval 'sub MA_RECURSED () {0x4;}' unless defined(&MA_RECURSED);
		eval 'sub MA_NOTRECURSED () {0x8;}' unless defined(&MA_NOTRECURSED);
	    }
	    if(defined(&INVARIANTS)) {
		eval 'sub mtx_assert {
		    my($m, $what) = @_;
    		    eval q( &_mtx_assert(($m), ($what),  &__FILE__,  &__LINE__));
		}' unless defined(&mtx_assert);
		eval 'sub GIANT_REQUIRED () { &mtx_assert( &Giant,  &MA_OWNED);}' unless defined(&GIANT_REQUIRED);
	    } else {
		eval 'sub mtx_assert {
		    my($m, $what) = @_;
    		    eval q();
		}' unless defined(&mtx_assert);
		eval 'sub GIANT_REQUIRED () {1;}' unless defined(&GIANT_REQUIRED);
	    }
	    eval 'sub MTX_NETWORK_LOCK () {"network driver";}' unless defined(&MTX_NETWORK_LOCK);
	}
    }
}
1;
