require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SIGNALVAR_H_)) {
    eval 'sub _SYS_SIGNALVAR_H_ () {1;}' unless defined(&_SYS_SIGNALVAR_H_);
    require 'sys/queue.ph';
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    require 'sys/signal.ph';
    eval 'sub PS_NOCLDWAIT () {0x1;}' unless defined(&PS_NOCLDWAIT);
    eval 'sub PS_NOCLDSTOP () {0x2;}' unless defined(&PS_NOCLDSTOP);
    eval 'sub PS_CLDSIGIGN () {0x4;}' unless defined(&PS_CLDSIGIGN);
    if(defined( &_KERNEL)  && defined( &COMPAT_43)) {
    }
    eval 'sub SIG_CATCH () {(( &__sighandler_t *)2);}' unless defined(&SIG_CATCH);
    eval 'sub SIG_HOLD () {(( &__sighandler_t *)3);}' unless defined(&SIG_HOLD);
    eval 'sub SIGACTION {
        my($p, $sig) = @_;
	    eval q(( ($p->{p_sigacts}->{ps_sigact[_SIG_IDX($sig)]})));
    }' unless defined(&SIGACTION);
    eval 'sub SIGADDSET {
        my($set, $signo) = @_;
	    eval q((($set). $__bits[ &_SIG_WORD($signo)] |=  &_SIG_BIT($signo)));
    }' unless defined(&SIGADDSET);
    eval 'sub SIGDELSET {
        my($set, $signo) = @_;
	    eval q((($set). $__bits[ &_SIG_WORD($signo)] &= ~ &_SIG_BIT($signo)));
    }' unless defined(&SIGDELSET);
    eval 'sub SIGEMPTYSET {
        my($set) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) ($set). $__bits[ &__i] = 0; }  &while (0));
    }' unless defined(&SIGEMPTYSET);
    eval 'sub SIGFILLSET {
        my($set) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) ($set). $__bits[ &__i] = ~0; }  &while (0));
    }' unless defined(&SIGFILLSET);
    eval 'sub SIGISMEMBER {
        my($set, $signo) = @_;
	    eval q((($set). $__bits[ &_SIG_WORD($signo)] &  &_SIG_BIT($signo)));
    }' unless defined(&SIGISMEMBER);
    eval 'sub SIGISEMPTY {
        my($set) = @_;
	    eval q(( &__sigisempty(($set))));
    }' unless defined(&SIGISEMPTY);
    eval 'sub SIGNOTEMPTY {
        my($set) = @_;
	    eval q((! &__sigisempty(($set))));
    }' unless defined(&SIGNOTEMPTY);
    eval 'sub SIGSETEQ {
        my($set1, $set2) = @_;
	    eval q(( &__sigseteq(($set1), ($set2))));
    }' unless defined(&SIGSETEQ);
    eval 'sub SIGSETNEQ {
        my($set1, $set2) = @_;
	    eval q((! &__sigseteq(($set1), ($set2))));
    }' unless defined(&SIGSETNEQ);
    eval 'sub SIGSETOR {
        my($set1, $set2) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) ($set1). $__bits[ &__i] |= ($set2). $__bits[ &__i]; }  &while (0));
    }' unless defined(&SIGSETOR);
    eval 'sub SIGSETAND {
        my($set1, $set2) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) ($set1). $__bits[ &__i] &= ($set2). $__bits[ &__i]; }  &while (0));
    }' unless defined(&SIGSETAND);
    eval 'sub SIGSETNAND {
        my($set1, $set2) = @_;
	    eval q( &do { \'int\'  &__i;  &for ( &__i = 0;  &__i <  &_SIG_WORDS;  &__i++) ($set1). $__bits[ &__i] &= ~($set2). $__bits[ &__i]; }  &while (0));
    }' unless defined(&SIGSETNAND);
    eval 'sub SIGSETLO {
        my($set1, $set2) = @_;
	    eval q((($set1). $__bits[0] = ($set2). $__bits[0]));
    }' unless defined(&SIGSETLO);
    eval 'sub SIGSETOLD {
        my($set, $oset) = @_;
	    eval q((($set). $__bits[0] = ($oset)));
    }' unless defined(&SIGSETOLD);
    eval 'sub SIG_CANTMASK {
        my($set) = @_;
	    eval q( &SIGDELSET($set,  &SIGKILL),  &SIGDELSET($set,  &SIGSTOP));
    }' unless defined(&SIG_CANTMASK);
    eval 'sub SIG_STOPSIGMASK {
        my($set) = @_;
	    eval q( &SIGDELSET($set,  &SIGSTOP),  &SIGDELSET($set,  &SIGTSTP),  &SIGDELSET($set,  &SIGTTIN),  &SIGDELSET($set,  &SIGTTOU));
    }' unless defined(&SIG_STOPSIGMASK);
    eval 'sub SIG_CONTSIGMASK {
        my($set) = @_;
	    eval q( &SIGDELSET($set,  &SIGCONT));
    }' unless defined(&SIG_CONTSIGMASK);
    eval 'sub sigcantmask () {( &sigmask( &SIGKILL) |  &sigmask( &SIGSTOP));}' unless defined(&sigcantmask);
    eval 'sub SIG2OSIG {
        my($sig, $osig) = @_;
	    eval q(($osig = ($sig). $__bits[0]));
    }' unless defined(&SIG2OSIG);
    eval 'sub OSIG2SIG {
        my($osig, $sig) = @_;
	    eval q( &SIGEMPTYSET($sig); ($sig). $__bits[0] = $osig);
    }' unless defined(&OSIG2SIG);
    eval 'sub __sigisempty {
        my($set) = @_;
	    eval q({ \'int\'  &i;  &for ( &i = 0;  &i <  &_SIG_WORDS;  &i++) {  &if ( ($set->{__bits[&i]})) (0); } (1); });
    }' unless defined(&__sigisempty);
    eval 'sub __sigseteq {
        my($set1,$set2) = @_;
	    eval q({ \'int\'  &i;  &for ( &i = 0;  &i <  &_SIG_WORDS;  &i++) {  &if ( ($set1->{__bits[&i]}) !=  ($set2->{__bits[&i]})) (0); } (1); });
    }' unless defined(&__sigseteq);
    if(defined(&_KERNEL)) {
	eval("sub SIGTARGET_P () { 0; }") unless defined(&SIGTARGET_P);
	eval("sub SIGTARGET_TD () { 1; }") unless defined(&SIGTARGET_TD);
	eval 'sub SIGPENDING {
	    my($td) = @_;
    	    eval q((! &SIGISEMPTY(($td)-> &td_siglist)  && ! &sigsetmasked(($td)-> &td_siglist, ($td)-> &td_sigmask)));
	}' unless defined(&SIGPENDING);
	eval 'sub SIGIO_LOCK () {
	    eval q( &mtx_lock( &sigio_lock));
	}' unless defined(&SIGIO_LOCK);
	eval 'sub SIGIO_TRYLOCK () {
	    eval q( &mtx_trylock( &sigio_lock));
	}' unless defined(&SIGIO_TRYLOCK);
	eval 'sub SIGIO_UNLOCK () {
	    eval q( &mtx_unlock( &sigio_lock));
	}' unless defined(&SIGIO_UNLOCK);
	eval 'sub SIGIO_LOCKED () {
	    eval q( &mtx_owned( &sigio_lock));
	}' unless defined(&SIGIO_LOCKED);
	eval 'sub SIGIO_ASSERT {
	    my($type) = @_;
    	    eval q( &mtx_assert( &sigio_lock, $type));
	}' unless defined(&SIGIO_ASSERT);
    }
}
1;
