require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SOCKETVAR_H_)) {
    eval 'sub _SYS_SOCKETVAR_H_ () {1;}' unless defined(&_SYS_SOCKETVAR_H_);
    require 'sys/queue.ph';
    require 'sys/selinfo.ph';
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    eval 'sub sb_startzero () { &sb_mb;}' unless defined(&sb_startzero);
    eval 'sub SB_MAX () {(256*1024);}' unless defined(&SB_MAX);
    eval 'sub SB_LOCK () {0x1;}' unless defined(&SB_LOCK);
    eval 'sub SB_WANT () {0x2;}' unless defined(&SB_WANT);
    eval 'sub SB_WAIT () {0x4;}' unless defined(&SB_WAIT);
    eval 'sub SB_SEL () {0x8;}' unless defined(&SB_SEL);
    eval 'sub SB_ASYNC () {0x10;}' unless defined(&SB_ASYNC);
    eval 'sub SB_UPCALL () {0x20;}' unless defined(&SB_UPCALL);
    eval 'sub SB_NOINTR () {0x40;}' unless defined(&SB_NOINTR);
    eval 'sub SB_AIO () {0x80;}' unless defined(&SB_AIO);
    eval 'sub SB_KNOTE () {0x100;}' unless defined(&SB_KNOTE);
    eval 'sub SB_EMPTY_FIXUP {
        my($sb) = @_;
	    eval q( &do {  &if (($sb)-> &sb_mb ==  &NULL) { ($sb)-> &sb_mbtail =  &NULL; ($sb)-> &sb_lastrecord =  &NULL; } }  &while ( 0));
    }' unless defined(&SB_EMPTY_FIXUP);
    eval 'sub ACCEPT_LOCK_ASSERT () {
        eval q( &mtx_assert( &accept_mtx,  &MA_OWNED));
    }' unless defined(&ACCEPT_LOCK_ASSERT);
    eval 'sub ACCEPT_UNLOCK_ASSERT () {
        eval q( &mtx_assert( &accept_mtx,  &MA_NOTOWNED));
    }' unless defined(&ACCEPT_UNLOCK_ASSERT);
    eval 'sub ACCEPT_LOCK () {
        eval q( &mtx_lock( &accept_mtx));
    }' unless defined(&ACCEPT_LOCK);
    eval 'sub ACCEPT_UNLOCK () {
        eval q( &mtx_unlock( &accept_mtx));
    }' unless defined(&ACCEPT_UNLOCK);
    eval 'sub SOCKBUF_MTX {
        my($_sb) = @_;
	    eval q((($_sb)-> &sb_mtx));
    }' unless defined(&SOCKBUF_MTX);
    eval 'sub SOCKBUF_LOCK_INIT {
        my($_sb, $_name) = @_;
	    eval q( &mtx_init( &SOCKBUF_MTX($_sb), $_name,  &NULL,  &MTX_DEF));
    }' unless defined(&SOCKBUF_LOCK_INIT);
    eval 'sub SOCKBUF_LOCK_DESTROY {
        my($_sb) = @_;
	    eval q( &mtx_destroy( &SOCKBUF_MTX($_sb)));
    }' unless defined(&SOCKBUF_LOCK_DESTROY);
    eval 'sub SOCKBUF_LOCK {
        my($_sb) = @_;
	    eval q( &mtx_lock( &SOCKBUF_MTX($_sb)));
    }' unless defined(&SOCKBUF_LOCK);
    eval 'sub SOCKBUF_OWNED {
        my($_sb) = @_;
	    eval q( &mtx_owned( &SOCKBUF_MTX($_sb)));
    }' unless defined(&SOCKBUF_OWNED);
    eval 'sub SOCKBUF_UNLOCK {
        my($_sb) = @_;
	    eval q( &mtx_unlock( &SOCKBUF_MTX($_sb)));
    }' unless defined(&SOCKBUF_UNLOCK);
    eval 'sub SOCKBUF_LOCK_ASSERT {
        my($_sb) = @_;
	    eval q( &mtx_assert( &SOCKBUF_MTX($_sb),  &MA_OWNED));
    }' unless defined(&SOCKBUF_LOCK_ASSERT);
    eval 'sub SOCKBUF_UNLOCK_ASSERT {
        my($_sb) = @_;
	    eval q( &mtx_assert( &SOCKBUF_MTX($_sb),  &MA_NOTOWNED));
    }' unless defined(&SOCKBUF_UNLOCK_ASSERT);
    eval 'sub SOCK_MTX {
        my($_so) = @_;
	    eval q( &SOCKBUF_MTX(($_so)-> &so_rcv));
    }' unless defined(&SOCK_MTX);
    eval 'sub SOCK_LOCK {
        my($_so) = @_;
	    eval q( &SOCKBUF_LOCK(($_so)-> &so_rcv));
    }' unless defined(&SOCK_LOCK);
    eval 'sub SOCK_OWNED {
        my($_so) = @_;
	    eval q( &SOCKBUF_OWNED(($_so)-> &so_rcv));
    }' unless defined(&SOCK_OWNED);
    eval 'sub SOCK_UNLOCK {
        my($_so) = @_;
	    eval q( &SOCKBUF_UNLOCK(($_so)-> &so_rcv));
    }' unless defined(&SOCK_UNLOCK);
    eval 'sub SOCK_LOCK_ASSERT {
        my($_so) = @_;
	    eval q( &SOCKBUF_LOCK_ASSERT(($_so)-> &so_rcv));
    }' unless defined(&SOCK_LOCK_ASSERT);
    eval 'sub SS_NOFDREF () {0x1;}' unless defined(&SS_NOFDREF);
    eval 'sub SS_ISCONNECTED () {0x2;}' unless defined(&SS_ISCONNECTED);
    eval 'sub SS_ISCONNECTING () {0x4;}' unless defined(&SS_ISCONNECTING);
    eval 'sub SS_ISDISCONNECTING () {0x8;}' unless defined(&SS_ISDISCONNECTING);
    eval 'sub SS_NBIO () {0x100;}' unless defined(&SS_NBIO);
    eval 'sub SS_ASYNC () {0x200;}' unless defined(&SS_ASYNC);
    eval 'sub SS_ISCONFIRMING () {0x400;}' unless defined(&SS_ISCONFIRMING);
    eval 'sub SS_ISDISCONNECTED () {0x2000;}' unless defined(&SS_ISDISCONNECTED);
    eval 'sub SBS_CANTSENDMORE () {0x10;}' unless defined(&SBS_CANTSENDMORE);
    eval 'sub SBS_CANTRCVMORE () {0x20;}' unless defined(&SBS_CANTRCVMORE);
    eval 'sub SBS_RCVATMARK () {0x40;}' unless defined(&SBS_RCVATMARK);
    eval 'sub SQ_INCOMP () {0x800;}' unless defined(&SQ_INCOMP);
    eval 'sub SQ_COMP () {0x1000;}' unless defined(&SQ_COMP);
    if(defined(&_KERNEL)) {
	eval 'sub sb_notify {
	    my($sb) = @_;
    	    eval q(((($sb)-> &sb_flags & ( &SB_WAIT |  &SB_SEL |  &SB_ASYNC |  &SB_UPCALL |  &SB_AIO |  &SB_KNOTE)) != 0));
	}' unless defined(&sb_notify);
	eval 'sub sbspace {
	    my($sb) = @_;
    	    eval q((  &imin((-> &sb_hiwat - -> &sb_cc), (($sb)-> &sb_mbmax - ($sb)-> &sb_mbcnt))));
	}' unless defined(&sbspace);
	eval 'sub sosendallatonce {
	    my($so) = @_;
    	    eval q((($so)-> ($so_proto->{pr_flags}) &  &PR_ATOMIC));
	}' unless defined(&sosendallatonce);
	eval 'sub soreadable {
	    my($so) = @_;
    	    eval q((($so)-> ($so_rcv->{sb_cc}) >= ($so)-> ($so_rcv->{sb_lowat}) || (($so)-> ($so_rcv->{sb_state}) &  &SBS_CANTRCVMORE) || ! &TAILQ_EMPTY(($so)-> &so_comp) || ($so)-> &so_error));
	}' unless defined(&soreadable);
	eval 'sub sowriteable {
	    my($so) = @_;
    	    eval q((( &sbspace(($so)-> &so_snd) >= ($so)-> ($so_snd->{sb_lowat})  && ((($so)-> &so_state &SS_ISCONNECTED) || (($so)-> ($so_proto->{pr_flags})& &PR_CONNREQUIRED)==0)) || (($so)-> ($so_snd->{sb_state}) &  &SBS_CANTSENDMORE) || ($so)-> &so_error));
	}' unless defined(&sowriteable);
	eval 'sub sballoc {
	    my($sb, $m) = @_;
    	    eval q({ ($sb)-> &sb_cc += ($m)-> &m_len;  &if (($m)-> &m_type !=  &MT_DATA  && ($m)-> &m_type !=  &MT_HEADER  && ($m)-> &m_type !=  &MT_OOBDATA) ($sb)-> &sb_ctl += ($m)-> &m_len; ($sb)-> &sb_mbcnt +=  &MSIZE;  &if (($m)-> &m_flags &  &M_EXT) ($sb)-> &sb_mbcnt += ($m)-> ($m_ext->{ext_size}); });
	}' unless defined(&sballoc);
	eval 'sub sbfree {
	    my($sb, $m) = @_;
    	    eval q({ ($sb)-> &sb_cc -= ($m)-> &m_len;  &if (($m)-> &m_type !=  &MT_DATA  && ($m)-> &m_type !=  &MT_HEADER  && ($m)-> &m_type !=  &MT_OOBDATA) ($sb)-> &sb_ctl -= ($m)-> &m_len; ($sb)-> &sb_mbcnt -=  &MSIZE;  &if (($m)-> &m_flags &  &M_EXT) ($sb)-> &sb_mbcnt -= ($m)-> ($m_ext->{ext_size}); });
	}' unless defined(&sbfree);
	eval 'sub sblock {
	    my($sb, $wf) = @_;
    	    eval q((($sb)-> &sb_flags &  &SB_LOCK ? ((($wf) ==  &M_WAITOK) ?  &sb_lock($sb) :  &EWOULDBLOCK) : (($sb)-> &sb_flags |=  &SB_LOCK, 0)));
	}' unless defined(&sblock);
	eval 'sub sbunlock {
	    my($sb) = @_;
    	    eval q( &do {  &SOCKBUF_LOCK_ASSERT($sb); ($sb)-> &sb_flags &= ~ &SB_LOCK;  &if (($sb)-> &sb_flags &  &SB_WANT) { ($sb)-> &sb_flags &= ~ &SB_WANT;  &wakeup(($sb)-> &sb_flags); } }  &while (0));
	}' unless defined(&sbunlock);
	eval 'sub soref {
	    my($so) = @_;
    	    eval q( &do {  &SOCK_LOCK_ASSERT($so); ++($so)-> &so_count; }  &while (0));
	}' unless defined(&soref);
	eval 'sub sorele {
	    my($so) = @_;
    	    eval q( &do {  &ACCEPT_LOCK_ASSERT();  &SOCK_LOCK_ASSERT($so);  &if (($so)-> &so_count <= 0)  &panic(\\"sorele\\");  &if (--($so)-> &so_count == 0)  &sofree($so);  &else {  &SOCK_UNLOCK($so);  &ACCEPT_UNLOCK(); } }  &while (0));
	}' unless defined(&sorele);
	eval 'sub sotryfree {
	    my($so) = @_;
    	    eval q( &do {  &ACCEPT_LOCK_ASSERT();  &SOCK_LOCK_ASSERT($so);  &if (($so)-> &so_count == 0)  &sofree($so);  &else {  &SOCK_UNLOCK($so);  &ACCEPT_UNLOCK(); } }  &while(0));
	}' unless defined(&sotryfree);
	eval 'sub sorwakeup_locked {
	    my($so) = @_;
    	    eval q( &do {  &SOCKBUF_LOCK_ASSERT(($so)-> &so_rcv);  &if ( &sb_notify(($so)-> &so_rcv))  &sowakeup(($so), ($so)-> &so_rcv);  &else  &SOCKBUF_UNLOCK(($so)-> &so_rcv); }  &while (0));
	}' unless defined(&sorwakeup_locked);
	eval 'sub sorwakeup {
	    my($so) = @_;
    	    eval q( &do {  &SOCKBUF_LOCK(($so)-> &so_rcv);  &sorwakeup_locked($so); }  &while (0));
	}' unless defined(&sorwakeup);
	eval 'sub sowwakeup_locked {
	    my($so) = @_;
    	    eval q( &do {  &SOCKBUF_LOCK_ASSERT(($so)-> &so_snd);  &if ( &sb_notify(($so)-> &so_snd))  &sowakeup(($so), ($so)-> &so_snd);  &else  &SOCKBUF_UNLOCK(($so)-> &so_snd); }  &while (0));
	}' unless defined(&sowwakeup_locked);
	eval 'sub sowwakeup {
	    my($so) = @_;
    	    eval q( &do {  &SOCKBUF_LOCK(($so)-> &so_snd);  &sowwakeup_locked($so); }  &while (0));
	}' unless defined(&sowwakeup);
	eval("sub SOPT_GET () { 0; }") unless defined(&SOPT_GET);
	eval("sub SOPT_SET () { 1; }") unless defined(&SOPT_SET);
	if(defined(&MALLOC_DECLARE)) {
	}
	if(defined(&SOCKBUF_DEBUG)) {
	    eval 'sub SBLASTRECORDCHK {
	        my($sb) = @_;
    		eval q( &sblastrecordchk(($sb),  &__FILE__,  &__LINE__));
	    }' unless defined(&SBLASTRECORDCHK);
	    eval 'sub SBLASTMBUFCHK {
	        my($sb) = @_;
    		eval q( &sblastmbufchk(($sb),  &__FILE__,  &__LINE__));
	    }' unless defined(&SBLASTMBUFCHK);
	} else {
	    eval 'sub SBLASTRECORDCHK {
	        my($sb) = @_;
    		eval q();
	    }' unless defined(&SBLASTRECORDCHK);
	    eval 'sub SBLASTMBUFCHK {
	        my($sb) = @_;
    		eval q();
	    }' unless defined(&SBLASTMBUFCHK);
	}
	if(defined(&ACCEPT_FILTER_MOD)) {
	    if(defined(&SYSCTL_DECL)) {
	    }
	}
    }
}
1;
