require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_SYSTM_H_)) {
    eval 'sub _SYS_SYSTM_H_ () {1;}' unless defined(&_SYS_SYSTM_H_);
    require 'machine/atomic.ph';
    require 'machine/cpufunc.ph';
    require 'sys/callout.ph';
    require 'sys/cdefs.ph';
    require 'sys/queue.ph';
    require 'sys/stdint.ph';
    if(defined(&INVARIANTS)) {
	eval 'sub KASSERT {
	    my($exp,$msg) = @_;
    	    eval q( &do {  &if ( &__predict_false(!($exp)))  &panic $msg; }  &while (0));
	}' unless defined(&KASSERT);
	eval 'sub VNASSERT {
	    my($exp, $vp, $msg) = @_;
    	    eval q( &do {  &if ( &__predict_false(!($exp))) {  &vn_printf($vp, \\"VNASSERT failed\\\\n\\");  &panic $msg; } }  &while (0));
	}' unless defined(&VNASSERT);
    } else {
	eval 'sub KASSERT {
	    my($exp,$msg) = @_;
    	    eval q();
	}' unless defined(&KASSERT);
	eval 'sub VNASSERT {
	    my($exp, $vp, $msg) = @_;
    	    eval q();
	}' unless defined(&VNASSERT);
    }
    unless(defined(&CTASSERT)) {
	eval 'sub CTASSERT {
	    my($x) = @_;
    	    eval q( &_CTASSERT($x,  &__LINE__));
	}' unless defined(&CTASSERT);
	eval 'sub _CTASSERT {
	    my($x, $y) = @_;
    	    eval q( &__CTASSERT($x, $y));
	}' unless defined(&_CTASSERT);
	eval 'sub __CTASSERT {
	    my($x, $y) = @_;
    	    eval q( &typedef \'char\'  &__assert  $y->[($x) ? 1: -1]);
	}' unless defined(&__CTASSERT);
    }
    if(defined(&RESTARTABLE_PANICS)) {
    } else {
    }
    eval 'sub HD_COLUMN_MASK () {0xff;}' unless defined(&HD_COLUMN_MASK);
    eval 'sub HD_DELIM_MASK () {0xff00;}' unless defined(&HD_DELIM_MASK);
    eval 'sub HD_OMIT_COUNT () {(1<< 16);}' unless defined(&HD_OMIT_COUNT);
    eval 'sub HD_OMIT_HEX () {(1<< 17);}' unless defined(&HD_OMIT_HEX);
    eval 'sub HD_OMIT_CHARS () {(1<< 18);}' unless defined(&HD_OMIT_CHARS);
    eval 'sub ovbcopy {
        my($f, $t, $l) = @_;
	    eval q( &bcopy(($f), ($t), ($l)));
    }' unless defined(&ovbcopy);
    eval 'sub SUSER_ALLOWJAIL () {1;}' unless defined(&SUSER_ALLOWJAIL);
    eval 'sub SUSER_RUID () {2;}' unless defined(&SUSER_RUID);
    if(defined(&APM_FIXUP_CALLTODO)) {
    }
    require 'sys/libkern.ph';
    eval 'sub CALLOUT_HANDLE_INITIALIZER {
        my($handle) = @_;
	    eval q({  &NULL });
    }' unless defined(&CALLOUT_HANDLE_INITIALIZER);
    eval 'sub splx {
        my($__unused) = @_;
	    eval q({ ; } \'int\'  &msleep( &void * &chan, \'struct mtx\' * &mtx, \'int\'  &pri,  &const \'char\' * &wmesg, \'int\'  &timo); \'int\'  &msleep_spin( &void * &chan, \'struct mtx\' * &mtx,  &const \'char\' * &wmesg, \'int\'  &timo);  &define  &tsleep( &chan,  &pri,  &wmesg,  &timo)  &msleep( &chan,  &NULL,  &pri,  &wmesg,  &timo)  &void  &wakeup( &void * &chan)  &__nonnull(1);  &void  &wakeup_one( &void * &chan)  &__nonnull(1); \'struct cdev\'; \'int\'  &minor(\'struct cdev\' * &x);  &dev_t  &dev2udev(\'struct cdev\' * &x); \'int\'  &uminor( &dev_t  &dev); \'int\'  &umajor( &dev_t  &dev);  &const \'char\' * &devtoname(\'struct cdev\' * &cdev);  &void  &DELAY(\'int\'  &usec); \'struct root_hold_token\'; \'struct root_hold_token\' * &root_mount_hold( &const \'char\' * &identifier);  &void  &root_mount_rel(\'struct root_hold_token\' * &h); \'struct unrhdr\'; \'struct unrhdr\' * &new_unrhdr(\'int\'  &low, \'int\'  &high, \'struct mtx\' * &mutex);  &void  &delete_unrhdr(\'struct unrhdr\' * &uh); \'int\'  &alloc_unr(\'struct unrhdr\' * &uh); \'int\'  &alloc_unrl(\'struct unrhdr\' * &uh);  &void  &free_unr(\'struct unrhdr\' * &uh, \'u_int\'  &item);  &uint32_t  &bitcount32( &uint32_t  &x) {  &x = ( &x & 0x55555555) + (( &x & 0xaaaaaaaa) >> 1);  &x = ( &x & 0x33333333) + (( &x & 0xcccccccc) >> 2);  &x = ( &x & 0xf0f0f0f) + (( &x & 0xf0f0f0f0) >> 4);  &x = ( &x & 0xff00ff) + (( &x & 0xff00ff00) >> 8);  &x = ( &x & 0xffff) + (( &x & 0xffff0000) >> 16); ( &x); });
    }' unless defined(&splx);
}
1;
