require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_UMTX_H_)) {
    eval 'sub _SYS_UMTX_H_ () {1;}' unless defined(&_SYS_UMTX_H_);
    require 'sys/limits.ph';
    eval 'sub UMTX_UNOWNED () {0x;}' unless defined(&UMTX_UNOWNED);
    eval 'sub UMTX_CONTESTED () { &LONG_MIN;}' unless defined(&UMTX_CONTESTED);
    eval 'sub UMTX_OP_LOCK () {0;}' unless defined(&UMTX_OP_LOCK);
    eval 'sub UMTX_OP_UNLOCK () {1;}' unless defined(&UMTX_OP_UNLOCK);
    eval 'sub UMTX_OP_WAIT () {2;}' unless defined(&UMTX_OP_WAIT);
    eval 'sub UMTX_OP_WAKE () {3;}' unless defined(&UMTX_OP_WAKE);
    unless(defined(&_KERNEL)) {
	eval 'sub umtx_owner {
	    my($umtx) = @_;
    	    eval q({ ( ($umtx->{u_owner}) & ~ &LONG_MIN); });
	}' unless defined(&umtx_owner);
	eval 'sub umtx_lock {
	    my($umtx,$id) = @_;
    	    eval q({  &if ( &atomic_cmpset_acq_ptr( ($umtx->{u_owner}), ( &void *) &UMTX_UNOWNED, ( &void *)$id) == 0)  &if ( &_umtx_lock($umtx) == -1) ( &errno); (0); });
	}' unless defined(&umtx_lock);
	eval 'sub umtx_trylock {
	    my($umtx,$id) = @_;
    	    eval q({  &if ( &atomic_cmpset_acq_ptr( ($umtx->{u_owner}), ( &void *) &UMTX_UNOWNED, ( &void *)$id) == 0) ( &EBUSY); (0); });
	}' unless defined(&umtx_trylock);
	eval 'sub umtx_timedlock {
	    my($umtx,$id,$timeout) = @_;
    	    eval q({  &if ( &atomic_cmpset_acq_ptr( ($umtx->{u_owner}), ( &void *) &UMTX_UNOWNED, ( &void *)$id) == 0)  &if ( &_umtx_op($umtx,  &UMTX_OP_LOCK, $id, 0, ( &void *)$timeout) == -1) ( &errno); (0); });
	}' unless defined(&umtx_timedlock);
	eval 'sub umtx_unlock {
	    my($umtx,$id) = @_;
    	    eval q({  &if ( &atomic_cmpset_rel_ptr( ($umtx->{u_owner}), ( &void *)$id, ( &void *) &UMTX_UNOWNED) == 0)  &if ( &_umtx_unlock($umtx) == -1) ( &errno); (0); });
	}' unless defined(&umtx_unlock);
	eval 'sub umtx_wait {
	    my($umtx,$id,$timeout) = @_;
    	    eval q({  &if ( &_umtx_op($umtx,  &UMTX_OP_WAIT, $id, 0, ( &void *)$timeout) == -1) ( &errno); (0); });
	}' unless defined(&umtx_wait);
    } else {
    }
}
1;
